import { Option } from '@glimmer/interfaces';
import { IterationItemReference } from './template';
import { PathReference, CachedReference } from './reference';
export interface IterationItem<T, U> {
    key: unknown;
    value: T;
    memo: U;
}
export interface AbstractIterator<T, U, V extends IterationItem<T, U>> {
    isEmpty(): boolean;
    next(): Option<V>;
}
export declare type OpaqueIterationItem = IterationItem<unknown, unknown>;
export declare type OpaqueIterator = AbstractIterator<unknown, unknown, OpaqueIterationItem>;
export interface IteratorDelegate {
    isEmpty(): boolean;
    next(): {
        value: unknown;
        memo: unknown;
    } | null;
}
export declare class IterableReference extends CachedReference<boolean> {
    private parentRef;
    private key;
    private iterator;
    constructor(parentRef: PathReference, key: string);
    isConst(): boolean;
    isDone(): boolean;
    compute(): boolean;
    isEmpty(): boolean;
    next(): Option<OpaqueIterationItem>;
    private createIterator;
    childRefFor(key: unknown, value: unknown): IterationItemReference<unknown>;
}
//# sourceMappingURL=iterable.d.ts.map