export interface Reference<T = unknown> {
    debugLabel?: string;
    value(): T;
    isConst(): boolean;
}
export default Reference;
export interface PathReference<T = unknown> extends Reference<T> {
    get(key: string): PathReference<unknown>;
}
export declare abstract class CachedReference<T = unknown> implements Reference<T> {
    private tag;
    private lastRevision;
    private lastValue;
    value(): T;
    isConst(): boolean;
    protected abstract compute(): T;
}
export declare class ReferenceCache<T> {
    private reference;
    private lastValue;
    constructor(reference: Reference<T>);
    revalidate(): Validation<T>;
}
export declare type Validation<T> = T | NotModified;
export declare type NotModified = typeof NOT_MODIFIED;
declare const NOT_MODIFIED: unique symbol;
export declare function isModified<T>(value: Validation<T>): value is T;
//# sourceMappingURL=reference.d.ts.map